SYM.WebApp/Controllers/InfoController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using SYM.DataAccessLayer;
using PagedList;
using NLog;
using SYM.BusinessLayer.Services;

namespace SYM.SearchEngine.MvcApp.Controllers
{
    public class InfoController : Controller
    {
        private Entities _context = new Entities();
        Logger logger = LogManager.GetCurrentClassLogger();

        // GET: /Stats/
        [OutputCache(Duration = 600)]
        public ActionResult Statistics()
        {
            //TODO: Singleton?
            InfoService infoService = new InfoService();
            var summaryStats = infoService.GetSummaryStats();

            ViewBag.counterMntn = summaryStats.counterMntn.ToString();
            ViewBag.counterMntnRange = summaryStats.counterMntnRange.ToString();
            ViewBag.counterMntnGroup = summaryStats.counterMntnGroup.ToString();
            ViewBag.counterRoute = summaryStats.counterRoutes.ToString();

            var source = _context.v_report_route4source.ToList();

            return View(source);
        }

        [OutputCache(Duration = 3600)]
        public ActionResult Partners()
        {
            //var source = _context.v_report_route4source.ToList();
            return View();
        }

        [OutputCache(Duration = 600)]
        public ActionResult _Mountain4Region()
        {
            IEnumerable<v_report_mountain4region> model = null;
            try
            {
                model = _context.v_report_mountain4region.ToList();
            }
            catch (Exception ex)
            {
                logger.Error(ex.Message);
            }

            return PartialView("~/Views/Info/Partial/_Mountain4Region.cshtml",model);
        }

    }
}

SYM.WebApp/Controllers/ProjectController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using SYM.BusinessLayer.Services;

namespace SYM.SearchEngine.MvcApp.Controllers
{
    public class ProjectController : Controller
    {
        //
        // GET: /Project/
        [OutputCache(Duration = 600)]
        public ActionResult Index()
        {
             //TODO: Singleton?
            InfoService infoService = new InfoService();
            var summaryStats = infoService.GetSummaryStats();

            ViewBag.counterMntn = summaryStats.counterMntn.ToString();
            ViewBag.counterMntnRange = summaryStats.counterMntnRange.ToString();
            ViewBag.counterMntnGroup = summaryStats.counterMntnGroup.ToString();
            ViewBag.counterRoute = summaryStats.counterRoutes.ToString();

            return View();
        }

    }
}

SYM.WebApp/Controllers/RouteController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Security.Claims;
using System.IO;
using SYM.DataAccessLayer;
using SYM.SearchEngine.MvcApp.Helpers;
using SYM.BusinessLayer;
using SYM.BusinessLayer.Services;
using CloudinaryDotNet.Actions;
using System.Web.Configuration;
using PagedList;
using NLog;
using System.Threading.Tasks;

namespace SYM.SearchEngine.MvcApp.Controllers
{
    public class RouteController : Controller
    {
        private Entities _context = new Entities();
        Logger logger = LogManager.GetCurrentClassLogger();

        //
        // GET: /Route/
        [Authorize]
        [OutputCache(Duration = 600, VaryByParam = "*", VaryByCustom = "User")]
        public ActionResult Index(FormCollection collection, string sortOrder, int? page, string currentFilter, string _route, string _mountain, string _country, string _region_text, string _mntn_text, string _act, string _source)
        {
            try
            {
                IEnumerable<route> routes = null;
                string meta = null;

                var identity = (ClaimsIdentity)User.Identity;
                IEnumerable<Claim> claims = identity.Claims.ToList();
                string profile_regionID = claims.FirstOrDefault(x => x.Type == "regionid").Value;
                string profile_countryID = claims.FirstOrDefault(x => x.Type == "countryid").Value;
                string profile_region = claims.FirstOrDefault(x => x.Type == ClaimTypes.StateOrProvince).Value;

                #region ViewBagInit
                if (collection.Count > 0)
                {
                    ViewBag.Mountain = String.IsNullOrEmpty(collection["mountain"]) ? null : collection["mountain"];
                    ViewBag.Mntn_text = String.IsNullOrEmpty(collection["mntn_text"]) ? null : collection["mntn_text"];
                    ViewBag.Range = String.IsNullOrEmpty(collection["range"]) ? "" : collection["range"];
                    ViewBag.Route_text = String.IsNullOrEmpty(collection["route_name"]) ? "" : collection["route_name"];
                    ViewBag.Route = String.IsNullOrEmpty(collection["route"]) ? null : collection["route"];
                    ViewBag.Country = String.IsNullOrEmpty(collection["country"]) ? null : collection["country"];
                    ViewBag.Region = String.IsNullOrEmpty(collection["region"]) ? null : collection["region"];
                    ViewBag.Activity = String.IsNullOrEmpty(collection["activity"]) ? "" : collection["activity"];
                    ViewBag.Region_text = String.IsNullOrEmpty(collection["region"]) ? "" : _context.geo_region.Find(Convert.ToInt32((string)ViewBag.Region)).region_name;
                    ViewBag.Sort = String.IsNullOrEmpty(collection["orderby"]) ? null : collection["orderby"];
                    meta = collection["meta"];

                    if (!String.IsNullOrEmpty(meta)) ViewBag.Route_text = meta;
                }
                else if (page >= 2)
                {
                    ViewBag.Region = String.IsNullOrEmpty(currentFilter) ? "0" : currentFilter;
                    ViewBag.Region_text = String.IsNullOrEmpty(_region_text) ? "" : _region_text;
                    ViewBag.Route_text = String.IsNullOrEmpty(_route) ? ViewBag.Route : _route;
                    ViewBag.Mountain = String.IsNullOrEmpty(_mountain) ? ViewBag.Mountain : _mountain;
                    ViewBag.Mntn_text = String.IsNullOrEmpty(_mntn_text) ? ViewBag.Mntn_text : _mntn_text;
                    ViewBag.Country = String.IsNullOrEmpty(_country) ? profile_countryID : _country;
                    ViewBag.Activity = String.IsNullOrEmpty(_act) ? "" : _act;
                    ViewBag.Source = String.IsNullOrEmpty(_source) ? "0" : _source;
                    ViewBag.Sort = String.IsNullOrEmpty(sortOrder) ? "" : sortOrder;
                }
                else if (Request.QueryString.HasKeys()) //If exists parameters I don't initialize some variables.
                {
                    ViewBag.Region = String.IsNullOrEmpty(currentFilter) ? "0" : currentFilter;
                    ViewBag.Region_text = String.IsNullOrEmpty(_region_text) ? "" : _region_text;
                    ViewBag.Route_text = String.IsNullOrEmpty(_route) ? ViewBag.Route : _route;
                    ViewBag.Mountain = String.IsNullOrEmpty(_mountain) ? ViewBag.Mountain : _mountain;
                    ViewBag.Mntn_text = String.IsNullOrEmpty(_mntn_text) ? ViewBag.Mntn_text : _mntn_text;
                    ViewBag.Country = String.IsNullOrEmpty(_country) ? "0" : _country;
                    ViewBag.Activity = String.IsNullOrEmpty(_act) ? "" : _act;
                    ViewBag.Source = String.IsNullOrEmpty(_source) ? "0" : _source;
                    ViewBag.Sort = String.IsNullOrEmpty(sortOrder) ? "" : sortOrder;
                }
                else
                {
                    ViewBag.Region = String.IsNullOrEmpty(currentFilter) ? profile_regionID : currentFilter;
                    ViewBag.Region_text = String.IsNullOrEmpty(_region_text) ? profile_region : _region_text;
                    ViewBag.Route_text = String.IsNullOrEmpty(_route) ? ViewBag.Route : _route;
                    ViewBag.Mountain = String.IsNullOrEmpty(_mountain) ? ViewBag.Mountain : _mountain;
                    ViewBag.Mntn_text = String.IsNullOrEmpty(_mntn_text) ? ViewBag.Mntn_text : _mntn_text;
                    ViewBag.Country = String.IsNullOrEmpty(_country) ? profile_countryID : _country;
                    ViewBag.Activity = String.IsNullOrEmpty(_act) ? "" : _act;
                    ViewBag.Source = String.IsNullOrEmpty(_source) ? "0" : _source;
                    ViewBag.Sort = String.IsNullOrEmpty(sortOrder) ? "" : sortOrder;
                }
                #endregion

                //Init Param
                string route = ViewBag.Route_text;
                int region = Convert.ToInt32((string)ViewBag.Region);
                int mountain = Convert.ToInt32((string)ViewBag.Mountain);
                int country = Convert.ToInt32((string)ViewBag.Country);
                int routeid = Convert.ToInt32((string)ViewBag.Route);
                int sourceid = Convert.ToInt32((string)ViewBag.Source);
                int valley = Convert.ToInt32((string)ViewBag.Valley);
                string tmp = ViewBag.Activity;
                List<int> activityArray = String.IsNullOrEmpty(tmp) ? null : tmp.Split(',').Select(Int32.Parse).ToList();

                //Init DropDown
                InitDropDownActivities(activityArray);

                if (routeid > 0)
                    return RedirectToAction("Details/" + routeid.ToString());

                //BL to extract data from database
                routes = GetRoutesFromDAL(region, country, mountain, valley, activityArray, route, meta, sourceid, (string)ViewBag.Sort);
                ViewBag.Count = routes.Count();

                int pageSize = 20;
                int pageNumber = (page ?? 1);
                return View(routes.ToPagedList(pageNumber, pageSize));
            }
            catch (Exception ex)
            {
                logger.Error(ex.Message);
                return View();
            }
        }

        //
        // GET: /Route/
        [OutputCache(Duration = 600, VaryByParam = "*", VaryByCustom = "User")]
        public ActionResult Index3(FormCollection collection, string sortOrder, int? page, string _reg, string _r, string _m, string _c, string _rtxt, string _mtxt, string _v, string _act)
        {
            IEnumerable<v_route_index> routes = null;
            string profile_regionID, profile_countryID, profile_region;

            //TODO: create Static Helper & Singleton 
            var identity = (ClaimsIdentity)User.Identity;
            if (identity.IsAuthenticated)
            {
                IEnumerable<Claim> claims = identity.Claims.ToList();
                profile_regionID = claims.FirstOrDefault(x => x.Type == "regionid").Value;
                profile_countryID = claims.FirstOrDefault(x => x.Type == "countryid").Value;
                profile_region = claims.FirstOrDefault(x => x.Type == ClaimTypes.StateOrProvince).Value;
            }
            else {
                profile_regionID = "1736";
                profile_countryID = "116";
                profile_region = "Lombardia";
            }

            #region ViewBagInit
            if (collection.Count > 0)
            {
                ViewBag.Mountain = String.IsNullOrEmpty(collection["mountain"]) ? null : collection["mountain"];
                ViewBag.Valley = String.IsNullOrEmpty(collection["valley"]) ? null : collection["valley"];
                ViewBag.Mntn_text = String.IsNullOrEmpty(collection["mntn_text"]) ? null : collection["mntn_text"];
                ViewBag.Meta = String.IsNullOrEmpty(collection["meta"]) ? null : collection["meta"];
                ViewBag.Range = String.IsNullOrEmpty(collection["range"]) ? "" : collection["range"];
                ViewBag.Route_text = String.IsNullOrEmpty(collection["route_name"]) ? "" : collection["route_name"];
                ViewBag.Route = String.IsNullOrEmpty(collection["route"]) ? null : collection["route"];
                ViewBag.Country = String.IsNullOrEmpty(collection["country"]) ? null : collection["country"];
                ViewBag.Region = String.IsNullOrEmpty(collection["region"]) ? null : collection["region"];
                ViewBag.Region_text = String.IsNullOrEmpty(collection["region"]) ? "" : _context.geo_region.Find(Convert.ToInt32((string)ViewBag.Region)).region_name;
                ViewBag.orderbySelected = String.IsNullOrEmpty(collection["orderby"]) ? null : collection["orderby"];
                ViewBag.Activity = String.IsNullOrEmpty(collection["activity"]) ? "" : collection["activity"];

SYM.WebApp/Views/Project/Index.cshtml
@{
    ViewBag.Title = "BigData";
    Layout = "~/Views/Shared/LandingPage/_Sleek.Home.cshtml";
}

<!-- SCREENSHOTS -->
<section class="shots" id="database">
    <div class="container">
        <div class="content-head">
            <h1>@SYM.Localization.Resources.Views.Home.Project.Section_Database</h1>
            <p>Il primo motore di ricerca e aggregatore per le attività di montagna.</p>
        </div>
        <div class="row">
            <div class="col-md-8">
                <h2 class="margin_20">@SYM.Localization.Resources.Views.Home.Project.Philosophy</h2>
                <h3 class="margin_20"><em>“A chi mi chiede: perché vai in montagna? gli rispondo se me lo  ....</em>“ <em>(Ed Viesturs).</em></h3>
            </div>
        </div>
        <div class="row">
            <div class="col-md-8">
                <p class="lead">Oggi con il proliferare di portali di settore, blog, piattaforme multimediali e social-network le informazioni sono distribuite per la rete. Questo scenario complica la ricerca di informazioni di montagne o itinerari, poco efficente o non favorisce la sicurezza (ex. divulgazione di pericoli).</p>
                <div class="clearfix space10"></div>
                <ul class="wt_styled_list">
                    <li>
                        <h4>I dati pubblici raccolti attraverso <b>crawler</b> e <b>open-data cartografici</b>.</h4>
                    </li>
                    <li>
                        <h4>Le informazioni raccolte o generate vengono condivisi con licenza <a href="http://creativecommons.org/licenses/by-sa/3.0/"><i class="fa fa-creative-commons"></i> Creative Commons</a></h4>
                    </li>
                    <li>
                        <h4>Indicizzazione di risorse esterne di qualità.</h4>
                    </li>
                    <li>
                        <h4><b>Social Media Aggregator</b> per alcune tipologie di contenuti.</h4>
                    </li>
                </ul>
            </div>
            <div class="col-md-4">
                <div class="feature-content">
                    <i class="fa fa-map-signs"></i>
                    <h4 data-counter="counterup" data-value="@ViewBag.counterRoute">0</h4>
                    <p>Topos</p>
                </div>
                <div class="feature-content">
                    <i class="fa fa-map"></i>
                    <h4 data-counter="counterup" data-value="@ViewBag.counterMntn">0</h4>
                    <p>Mountains</p>
                </div>
                <div class="feature-content">
                    <i class="fa fa-toggle-on"></i>
                    <h4 data-counter="counterup" data-value="@ViewBag.counterMntnRange">0</h4>
                    <p>Mountains Range</p>
                </div>
            </div>
        </div>
    </div>
</section>
<!-- SCREENSHOTS -->
<!-- ABOUT / INFO CONTENT -->
<div class="wrap-content" id="experience">
    <div class="container">
        <div class="row">
            <div class="col-md-5">
                <h2>@SYM.Localization.Resources.Views.Home.Project.Section_Experience</h2>
                <p class="lead"><b>Ognuno di noi durante le proprie avventure è mosso da differenti motivazioni e prova emozioni diverse.</b></p>
                <p class="lead">Ma queste esperienze generano informazioni oggettive... lascia una traccia del tuo cammino su questo network con dati GPS, immagini, stato del percorso o semplici impressioni. In questo modo potrai aiutare chi vorrà ripetere la tua avventura.</p>
                <div class="clearfix space10"></div>
                    <a href="@Url.Action("index3","Route")" class="btn-main btn-left btn-white">@SYM.Localization.Resources.Views.Home.Project.LearnMore</a>
            </div>
            <div class="col-md-7">
                <img class="img-responsive" src="https://theme.express/sleek/sleek/images/2.png" alt="">
            </div>
        </div>
    </div>
</div>
<!-- ABOUT / INFO CONTENT -->
<!-- ABOUT / INFO CONTENT -->
<section class="wrap-content wrap-content1" id="discovery">
    <div class="container">
        <div class="row">
            <div class="col-md-7">
                <img class="img-responsive" src="~/Content/themes/sleek/images/tablet.png" alt="">
            </div>
            <div class="col-md-5">
                <h2>@SYM.Localization.Resources.Views.Home.Project.Section_Discovery</h2>
                <p class="lead"><b>I dati raccolti nella piattaforma vengono ri-classificati in un database per semplificarne la ricerca.</b></p>
                <p class="lead">Queste informazioni verranno poi messe in relazione con i dati sparsi sulla rete (forum / social network / siti di settore). Attraverso strumenti di <b>Data Analysis</b> la piattaforma cerca di offrire una visione dei <b>trend</b> legati alle attività outdoor e dei luoghi (magari poco valorizzati) presenti vicino a noi.</p>
                @*<p class="lead">Oggi grazie rete siamo circondati da informazioni in modo caotico sparse sui forum, siti di settore e social network. Analizzandoli è possibile entrare in contatto con persone con le nostre passioni e conoscere luoghi stupendi vicino casa mai visti senza doversi ….
                    Analizza i trend e la distribuzione dei dati nel corso del corso….</p>*@
                <div class="clearfix space20"></div>
                <a href="@Url.Action("Statistics","Info")" class="btn-main btn-left">@SYM.Localization.Resources.Views.Home.Project.LearnMore</a>
            </div>
        </div>
    </div>
</section>
<!-- ABOUT / INFO CONTENT -->
<!-- NEWSLETTER -->
<div class="home-subscribe">
    <div class="container">
        <div class="row">
            <h6>@SYM.Localization.Resources.Views.Home.Home.SubscribeNewsletter</h6>
            <div class="intro-newsletter">
                <form class="subscribe" action="http://api.shareyourmountain.com/subscribe.php" id="invite" method="POST">
                    <input class="e-mail" placeholder="@SYM.Localization.Resources.Views.Home.Home.Subscribe_placeholder" name="email" id="address" data-validate="validate(required, email)" type="email">
                    <button type="submit"><i class="fa fa-paper-plane-o"></i></button>
                </form>
                <span id="result_nl"></span>
            </div>
        </div>
    </div>
</div>
<!-- NEWSLETTER -->
@section ExtraPageJS {
    <script src="~/Content/themes/m1/assets/global/plugins/counterup/jquery.waypoints.min.js" type="text/javascript"></script>
    <script src="~/Content/themes/m1/assets/global/plugins/counterup/jquery.counterup.min.js" type="text/javascript"></script>
    <script src="~/Content/themes/sleek/js/project.js"></script>
}